﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using MaterialSkin;
using MaterialSkin.Controls;
using System.IO;
using System.Configuration;
using System.Windows.Forms.Integration;
using System.Windows.Controls;

namespace Onboarding
{
    public partial class Onboarding : MaterialForm
    {
        private string connectionString = @"Password=AaY/X4*)Q6v'#ZBm;Persist Security Info=True;User ID=Onboarding;Initial Catalog=Onboarding;Data Source=ISPC0005";
        private string UserName = Environment.UserName;
        private string accessLevel = "";
        private bool newUserStatus;
        private bool reHireStatus;
        private string lastEditedDateTime;
        private bool ADAccount;
        private bool Empath;
        private bool emailSent;
        private bool Rfs;
        private int endDate;
        private System.Windows.Controls.TextBox textBox;
        private bool declineOfferV;
        private string currentVersion = "1.1.1";
        private string currentBuild = "10.01.2022";
        private string ISID = Environment.MachineName;
        private bool accessAllowed = false;

        public bool recordComplete { get; private set; }

        public Onboarding()
        {
            InitializeComponent();
            // Create a material theme manager and add the form to manage (this)
            var materialSkinManager = MaterialSkinManager.Instance;
            materialSkinManager.AddFormToManage(this);
            materialSkinManager.Theme = MaterialSkinManager.Themes.LIGHT;
            // Configure color schema
            materialSkinManager.ColorScheme = new ColorScheme(Primary.Blue800, Primary.Blue900, Primary.Blue500, Accent.LightBlue200, TextShade.WHITE);
            authenticateUser();
            
        }
        /// <summary>
        /// Reads the records stored in the database
        /// </summary>
        private void readDataBaseEntries()
        {
            //Determine the historical data to show
            endDate = -1;
            DateTime entryID = DateTime.Now;
            DateTime historical = entryID.AddMonths(endDate);

            try
            {
                String query = "select * from EmployeeRecords WHERE StartDate >'" + historical.ToString("yyyy-MM-dd") + "'";
                SqlConnection connection = new SqlConnection(connectionString);
                SqlCommand command = new SqlCommand(query, connection);
                connection.Open();
                DataSet ds = new DataSet();
                DataTable dt = new DataTable();
                SqlDataAdapter sda = new SqlDataAdapter(command);
                sda.Fill(dt);
                newEmployeeDataGrid.DataSource = dt;
                connection.Close();
                dataBaseConnection();
                //dbCount();

            }
            catch
            {
                MessageBox.Show("Unable to read Database.", "Access Denied", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }

        }
                          
        /// <summary>
        /// Authenticate user and provide the correct access level
        /// </summary>
        private void authenticateUser()
        {
            currentUser.Text = UserName.ToUpper();
            dataBaseConnection();

            try
            {
                String query = "select * from AppUsers Where Username = '" + UserName + "'AND ISID = '" + ISID + "'";
                SqlConnection connection = new SqlConnection(connectionString);
                SqlCommand command = new SqlCommand(query, connection);
                connection.Open();
                DataSet ds = new DataSet();
                DataTable dt = new DataTable();
                SqlDataAdapter sda = new SqlDataAdapter(command);
                sda.Fill(dt);
                if (dt.Rows.Count > 0)
                {
                    accessLevel = dt.Rows[0]["AccessLevel"].ToString().Trim();
                    userAccessLevel.Text = accessLevel;
                    accessAllowed = true;
                    statusCheck();
                    CheckBuild();
                    theISID.Text = ISID;
                }
                else
                {
                    MessageBox.Show("You are not autherized to user this app on this station.", "Access Denied", MessageBoxButtons.OK, MessageBoxIcon.Stop);
                }

                connection.Close();

                

                if (accessLevel == "Helpdesk Support" && accessAllowed == true)
                {
                    additionalNotes.ReadOnly = false;
                    grhEmail.ReadOnly = false;
                    adAccountComplete.Enabled = true;
                    empathEntered.Enabled = true;
                    rfsReceived.Enabled = true;
                    pdfFileEmailed.Enabled = true;
                    NES_Save_Btn_.Enabled = true;
                    newEmployeeComplete.Enabled = true;
                }
                if (accessLevel == "Helpdesk Admin" && accessAllowed == true)
                {
                    //Helpdesk Access
                    additionalNotes.ReadOnly = false;
                    grhEmail.ReadOnly = false;
                    adAccountComplete.Enabled = true;
                    empathEntered.Enabled = true;
                    rfsReceived.Enabled = true;
                    pdfFileEmailed.Enabled = true;
                    NES_Save_Btn_.Enabled = true;
                    newEmployeeComplete.Enabled = true;
                    //HR Access
                    firstName.ReadOnly = false;
                    lastName.ReadOnly = false;
                    employeeID.ReadOnly = false;
                    accessPin.ReadOnly = false;
                    EplPpl.ReadOnly = false;
                    personalEmail.ReadOnly = false;
                    NEE_Delete_Btn_.Enabled = true;
                    NEE_Reset_Btn_.Enabled = true;
                    NEE_Save_Btn_.Enabled = true;
                    NEE_Edit_Btn.Enabled = true;
                    declineOffer.Enabled = true;
                    reHire.Enabled = true;

                }
                if (accessLevel == "Onboarding_IT" && accessAllowed == true)
                {
                    firstName.ReadOnly = false;
                    lastName.ReadOnly = false;
                    employeeID.ReadOnly = false;
                    accessPin.ReadOnly = false;
                    EplPpl.ReadOnly = false;
                    personalEmail.ReadOnly = false;
                    NEE_Delete_Btn_.Enabled = true;
                    NEE_Reset_Btn_.Enabled = true;
                    NEE_Save_Btn_.Enabled = true;
                    NEE_Edit_Btn.Enabled = true;
                    declineOffer.Enabled = true;
                    reHire.Enabled = true;

                }
                if (accessLevel == "Occupational Health" && accessAllowed == true)
                {
                    firstName.ReadOnly = false;
                    lastName.ReadOnly = false;
                    NEE_Delete_Btn_.Enabled = true;
                    NEE_Reset_Btn_.Enabled = true;
                }

            }
            catch
            {
                MessageBox.Show("Please check network connection","Connection Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }





        }

        /// <summary>
        /// Checking database connection
        /// </summary>
        private void dataBaseConnection()
        {
            try
            {
                SqlConnection testConnection = new SqlConnection(connectionString);
                testConnection.Open();
                testConnection.Close();
                dataBaseConnectionStatus.Image = Properties.Resources.unnamed;
                
            }
            catch
            {
                dataBaseConnectionStatus.Image = Properties.Resources.desconnect;
            }
        }
        /// <summary>
        /// Test the database Connection at an interval
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void testConnection_Tick(object sender, EventArgs e)
        {
            dataBaseConnection();
        }

        /// <summary>
        /// This method validate the new user input section
        /// </summary>
        private void validateNewUserInput()
        {
            if(!String.IsNullOrEmpty(firstName.Text) && !String.IsNullOrEmpty(lastName.Text)&& !String.IsNullOrEmpty(personalEmail.Text))
            {
                validateNewuserEntry();
                
            }
            else
            {
                MessageBox.Show("Please check mandatory fields", "Missing Information",MessageBoxButtons.OK,MessageBoxIcon.Hand);
            }


        }
        /// <summary>
        /// This method validates if the user exist in the database
        /// </summary>
        /// <returns></returns>
        private void validateNewuserEntry()
        {
            using (SqlConnection con = new SqlConnection(connectionString))
            {
                string query = "select * from EmployeeRecords Where FirstName=@FirstName AND LastName=@LastName";
                using (SqlDataAdapter adap = new SqlDataAdapter(query, con))
                {
                    con.Open();
                    DataTable dt = new DataTable();
                    adap.SelectCommand.Parameters.AddWithValue("@FirstName", firstName.Text);
                    adap.SelectCommand.Parameters.AddWithValue("@LastName", lastName.Text);
                    adap.Fill(dt);

                    if (dt.Rows.Count > 0)
                    {
                                       

                        DialogResult result = MessageBox.Show("This person already exist, is this a new Re-Hire?\nYES - Entry will be entered as re-hire.\nNO - Entry will be entered as new hire\nCancel - New entry process will be canceled.","Duplicate Entry Found",MessageBoxButtons.YesNoCancel,MessageBoxIcon.Exclamation);
                        if(result == DialogResult.Yes)
                        {
                            reHire.Checked = true;
                            reHireStatus = true;
                            newUserStatus = false;
                            addNewDataBaseEntry();
                        }
                        if(result == DialogResult.No)
                        {
                            newUserStatus = true;
                            reHireStatus = false;
                            addNewDataBaseEntry();
                        }
                        if(result == DialogResult.Cancel)
                        {

                        }

                    }
                    else
                    {
                        addNewDataBaseEntry();
                    }
                }
            }
                                                     
        }
        /// <summary>
        /// This method adds a new entry to the database.
        /// </summary>
        private void addNewDataBaseEntry()
        {
            DateTime entryID = DateTime.Now;
            recordID.Text = entryID.ToString("yyMMddHHmm");
            lastEditedDateTime = entryID.ToString("yyyy-MM-dd-HH:mm");
            SqlConnection connection = new SqlConnection(connectionString);
            SqlCommand command = new SqlCommand("Insert into EmployeeRecords (ID,FirstName,LastName,NewHire,ReHire,StartDate,EmployeeNumber,PersonalEmail, EPL_PPL, PinCode, AdditionalNote, LastEditedBy, DateEdited) Values(@ID, @FirstName, @LastName,@NewHire,@Rehire, @StartDate, @EmployeeNumber, @PersonalEmail, @EPL_PPL, @PinCode, @AdditionalNote, @LastEditedBy, @DateEdited)", connection);
            command.Parameters.AddWithValue("@ID", recordID.Text);
            command.Parameters.AddWithValue("@FirstName", firstName.Text);
            command.Parameters.AddWithValue("@LastName", lastName.Text);
            command.Parameters.AddWithValue("@NewHire", newUserStatus);
            command.Parameters.AddWithValue("@ReHire", reHireStatus);
            command.Parameters.AddWithValue("@StartDate", NEE_StartDate_Picker.Value.ToString("dd-MMM-yy"));
            command.Parameters.AddWithValue("@EmployeeNumber", employeeID.Text);
            command.Parameters.AddWithValue("@PersonalEmail", personalEmail.Text);
            command.Parameters.AddWithValue("@EPL_PPL", EplPpl.Text);
            command.Parameters.AddWithValue("@PinCode", accessPin.Text);
            command.Parameters.AddWithValue("@AdditionalNote", additionalNotes.Text);
            command.Parameters.AddWithValue("@LastEditedBy", UserName.ToUpper());
            command.Parameters.AddWithValue("@DateEdited", lastEditedDateTime);
            connection.Open();
            command.ExecuteNonQuery();
            connection.Close();
            MessageBox.Show("The record for: " + firstName.Text + " " + lastName.Text + " have been added", "User Added to Database", MessageBoxButtons.OK, MessageBoxIcon.Information);
            LogUserActivities("Add New Record", recordID.Text);
        }
        /// <summary>
        /// This method edits an existing database entry
        /// </summary>
        private void editNewdataBaseEntry()
        {
            if(declineOffer.Checked == true) { declineOfferV = true; } else { declineOfferV = false; }
            DateTime entryID = DateTime.Now;
            lastEditedDateTime = entryID.ToString("yyyy-MM-dd-HH:mm");
            SqlConnection connection = new SqlConnection(connectionString);
            SqlCommand command = new SqlCommand("Update EmployeeRecords Set FirstName=@FirstName, LastName=@LastName, StartDate=@StartDate, EmployeeNumber=@EmployeeNumber, PersonalEmail=@PersonalEmail, EPL_PPL=@EPL_PPL, PinCode=@PinCode, AdditionalNote=@AdditionalNote, OfferDeclined=@OfferDeclined, LastEditedBy=@LastEditedBy, DateEdited=@DateEdited Where ID=@ID", connection);
            command.Parameters.AddWithValue("@ID", recordID.Text);
            command.Parameters.AddWithValue("@FirstName", firstName.Text);
            command.Parameters.AddWithValue("@LastName", lastName.Text);
            command.Parameters.AddWithValue("@StartDate", NEE_StartDate_Picker.Value.ToString("dd-MMM-yy"));
            command.Parameters.AddWithValue("@EmployeeNumber", employeeID.Text);
            command.Parameters.AddWithValue("@PersonalEmail", personalEmail.Text);
            command.Parameters.AddWithValue("@EPL_PPL", EplPpl.Text);
            command.Parameters.AddWithValue("@PinCode", accessPin.Text);
            command.Parameters.AddWithValue("@OfferDeclined", declineOfferV);
            command.Parameters.AddWithValue("@AdditionalNote", additionalNotes.Text);
            command.Parameters.AddWithValue("@LastEditedBy", UserName.ToUpper());
            command.Parameters.AddWithValue("@DateEdited", lastEditedDateTime);
            connection.Open();
            command.ExecuteNonQuery();
            connection.Close();
            MessageBox.Show("The record for: " + firstName.Text + " " + lastName.Text + " have been updated", "User Entry Updated", MessageBoxButtons.OK, MessageBoxIcon.Information);
            LogUserActivities("Update Record", recordID.Text);
        }
        /// <summary>
        /// This method is completed by helpdesk to close off the new employee task
        /// </summary>
        private void completeNewDataBaseEntry()
        {
            DateTime entryID = DateTime.Now;
            lastEditedDateTime = entryID.ToString("yyyy-MM-dd-HH:mm");
            if (adAccountComplete.Checked == true)
            {
                ADAccount = true;
            }
            else
            {
                ADAccount = false;
            }
            if (empathEntered.Checked == true)
            {
                Empath = true;
            }
            else
            {
                Empath = false;
            }
            if (pdfFileEmailed.Checked == true)
            {
                emailSent = true;
            }
            else
            {
                emailSent = false;
            }
            if (rfsReceived.Checked == true)
            {
                Rfs = true;
            }
            else
            {
                Rfs = false;
            }
            if (newEmployeeComplete.Checked == true)
            {
                recordComplete = true;
            }
            else
            {
                recordComplete = false;
            }
            SqlConnection connection = new SqlConnection(connectionString);
            SqlCommand command = new SqlCommand("Update EmployeeRecords Set GRHEmail=@GRHEmail, ADAccount=@ADAccount, Empath=@Empath, RFS=@RFS, EmailSent=@EmailSent, AdditionalNote=@AdditionalNote, Complete=@Complete, LastEditedBy=@LastEditedBy, DateEdited=@DateEdited Where ID=@ID", connection);
            command.Parameters.AddWithValue("@ID", recordID.Text);
            command.Parameters.AddWithValue("@GRHEmail", grhEmail.Text);
            command.Parameters.AddWithValue("@ADAccount", ADAccount);
            command.Parameters.AddWithValue("@Empath", Empath);
            command.Parameters.AddWithValue("@RFS", Rfs);
            command.Parameters.AddWithValue("@EmailSent", emailSent);
            command.Parameters.AddWithValue("@AdditionalNote", additionalNotes.Text);
            command.Parameters.AddWithValue("@Complete", recordComplete);
            command.Parameters.AddWithValue("@LastEditedBy", UserName.ToUpper());
            command.Parameters.AddWithValue("@DateEdited", lastEditedDateTime);
            connection.Open();
            command.ExecuteNonQuery();
            connection.Close();
            MessageBox.Show("The record for: " + firstName.Text + " " + lastName.Text + " have been updated", "User Entry Updated", MessageBoxButtons.OK, MessageBoxIcon.Information);
            LogUserActivities("Update Record", recordID.Text);
        }
        /// <summary>
        /// This method displays the selected enrty
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void newEmployeeDataGrid_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {
            
            if(e.RowIndex >=0)
            {
                DataGridViewRow row = this.newEmployeeDataGrid.Rows[e.RowIndex];
                recordID.Text = row.Cells["ID"].Value.ToString();
                firstName.Text = row.Cells["Firstname"].Value.ToString();
                lastName.Text = row.Cells["LastName"].Value.ToString();
                accessPin.Text = row.Cells["PinCode"].Value.ToString();
                NEE_StartDate_Picker.Value = DateTime.Parse(row.Cells["StartDate"].Value.ToString());
                personalEmail.Text = row.Cells["PersonalEmail"].Value.ToString();
                employeeID.Text = row.Cells["EmployeeNumber"].Value.ToString();
                grhEmail.Text = row.Cells["GRHEmail"].Value.ToString();
                EplPpl.Text = row.Cells["EPL_PPL"].Value.ToString();
                additionalNotes.Text = row.Cells["AdditionalNote"].Value.ToString();
                if (row.Cells["ADAccount"].Value.ToString() == "True") { adAccountComplete.Checked = true; } else { adAccountComplete.Checked = false; }
                if(row.Cells["Empath"].Value.ToString() == "True") { empathEntered.Checked = true; } else { empathEntered.Checked = false; }
                if(row.Cells["EmailSent"].Value.ToString() == "True") { pdfFileEmailed.Checked = true; } else { pdfFileEmailed.Checked = false; }
                if(row.Cells["RFS"].Value.ToString() == "True") { rfsReceived.Checked = true; } else { rfsReceived.Checked = false; }
                if(row.Cells["OfferDeclined"].Value.ToString() == "True") { declineOffer.Checked = true; } else { declineOffer.Checked = false; }
                if(row.Cells["Complete"].Value.ToString() == "True") { newEmployeeComplete.Checked = true; } else { newEmployeeComplete.Checked = false; }
                if (grhEmail.Text.Contains("@grhosp.on.ca")) { grhEmailComplete.Image = Properties.Resources.pass; } else { grhEmailComplete.Image = Properties.Resources.excl2; }
                LogUserActivities("Select Record", recordID.Text);


            }
        }
        /// <summary>
        /// define the status of a new hire by color
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void newEmployeeDataGrid_CellFormatting(object sender, DataGridViewCellFormattingEventArgs e)
        {
            try
            {
                foreach (DataGridViewRow row in newEmployeeDataGrid.Rows)
                {
                    if (Convert.ToBoolean(row.Cells[16].Value) == true)
                    {
                       
                        row.Cells[16].Style.BackColor = Color.Red;
                    }

                    if (Convert.ToBoolean(row.Cells[17].Value) == true)
                    {
                        
                        row.Cells[17].Style.BackColor = Color.LightGreen;
                    }

                }

            }
            catch
            {

            }

        }

        /// <summary>
        /// This method deletes a new employee entry
        /// </summary>
        private void deleteNewEmployeeEntry()
        {
            SqlConnection connection = new SqlConnection(connectionString);
            SqlCommand command = new SqlCommand("Delete from EmployeeRecords Where ID='" + recordID.Text + "'", connection);
            connection.Open();
            command.ExecuteNonQuery();
            connection.Close();

            SqlCommand command02 = new SqlCommand("select * from EmployeeRecords Where FirstName='" + firstName.Text + "'AND LastName = '" + lastName.Text + "'", connection);
            connection.Open();
            command02.ExecuteNonQuery();
            DataSet ds = new DataSet();
            DataTable dt = new DataTable();
            SqlDataAdapter sda = new SqlDataAdapter(command02);
            sda.Fill(dt);
            newEmployeeDataGrid.DataSource = dt;
            connection.Close();
            LogUserActivities("Delete Record", recordID.Text);

        }
        
        /// <summary>
        /// This method search the database for a new hire
        /// </summary>
        private void newEmployeeEntrySearch()
        {
            if (!String.IsNullOrEmpty(firstNameSearch.Text) && !String.IsNullOrEmpty(lastNameSearch.Text) && dateRangeFilter.Checked == false)
            {
                try
                {
                    String query = "select * from EmployeeRecords Where FirstName = '" + firstNameSearch.Text + "'AND LastName = '" + lastNameSearch.Text + "'";
                    SqlConnection connection = new SqlConnection(connectionString);
                    SqlCommand command = new SqlCommand(query, connection);
                    connection.Open();
                    DataSet ds = new DataSet();
                    DataTable dt = new DataTable();
                    SqlDataAdapter sda = new SqlDataAdapter(command);
                    sda.Fill(dt);
                    newEmployeeDataGrid.DataSource = dt;
                    connection.Close();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }
            }

            if (!String.IsNullOrEmpty(firstNameSearch.Text) && String.IsNullOrEmpty(lastNameSearch.Text) && dateRangeFilter.Checked == false)
            {
                try
                {
                    String query = "select * from EmployeeRecords Where FirstName='" + firstNameSearch.Text + "'";
                    SqlConnection connection = new SqlConnection(connectionString);
                    SqlCommand command = new SqlCommand(query, connection);
                    connection.Open();
                    DataSet ds = new DataSet();
                    DataTable dt = new DataTable();
                    SqlDataAdapter sda = new SqlDataAdapter(command);
                    sda.Fill(dt);
                    newEmployeeDataGrid.DataSource = dt;
                    connection.Close();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }
            }
            if (String.IsNullOrEmpty(firstNameSearch.Text) && !String.IsNullOrEmpty(lastNameSearch.Text) && dateRangeFilter.Checked == false)
            {
                try
                {
                    String query = "select * from EmployeeRecords Where LastName='" + lastNameSearch.Text + "'";
                    SqlConnection connection = new SqlConnection(connectionString);
                    SqlCommand command = new SqlCommand(query, connection);
                    connection.Open();
                    DataSet ds = new DataSet();
                    DataTable dt = new DataTable();
                    SqlDataAdapter sda = new SqlDataAdapter(command);
                    sda.Fill(dt);
                    newEmployeeDataGrid.DataSource = dt;
                    connection.Close();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }
            }
            if (dateRangeFilter.Checked == true && String.IsNullOrEmpty(firstNameSearch.Text) && String.IsNullOrEmpty(lastNameSearch.Text))
            {
                try
                {
                    String query = "select * from EmployeeRecords Where StartDate >='" + startDateSearch.Value + "' AND StartDate <='" + endDateSearch.Value + "'";
                    SqlConnection connection = new SqlConnection(connectionString);
                    SqlCommand command = new SqlCommand(query, connection);
                    connection.Open();
                    DataSet ds = new DataSet();
                    DataTable dt = new DataTable();
                    SqlDataAdapter sda = new SqlDataAdapter(command);
                    sda.Fill(dt);
                    newEmployeeDataGrid.DataSource = dt;
                    connection.Close();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }

                //firstNameSearch.Text = "";
                //lastNameSearch.Text = "";
                //dt.DefaultView.RowFilter = String.Format("[StartDate] >= #{0:yyyy-MM-dd}# And [StartDate] <= #{1:yyyy-MM-dd}#", startDateSearch.Value, endDateSearch.Value);
            }
            if (dateRangeFilter.Checked == true && !String.IsNullOrEmpty(firstNameSearch.Text) && String.IsNullOrEmpty(lastNameSearch.Text))
            {
                try
                {
                    String query = "select * from EmployeeRecords Where StartDate >='" + startDateSearch.Value + "' AND StartDate <='" + endDateSearch.Value + "' AND FirstName='" + firstNameSearch.Text + "'";
                    SqlConnection connection = new SqlConnection(connectionString);
                    SqlCommand command = new SqlCommand(query, connection);
                    connection.Open();
                    DataSet ds = new DataSet();
                    DataTable dt = new DataTable();
                    SqlDataAdapter sda = new SqlDataAdapter(command);
                    sda.Fill(dt);
                    newEmployeeDataGrid.DataSource = dt;
                    connection.Close();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }
            }
            if (dateRangeFilter.Checked == true && String.IsNullOrEmpty(firstNameSearch.Text) && !String.IsNullOrEmpty(lastNameSearch.Text))
            {
                try
                {
                    String query = "select * from EmployeeRecords Where StartDate >='" + startDateSearch.Value + "' AND StartDate <='" + endDateSearch.Value + "' AND LastName='" + lastNameSearch.Text + "'";
                    SqlConnection connection = new SqlConnection(connectionString);
                    SqlCommand command = new SqlCommand(query, connection);
                    connection.Open();
                    DataSet ds = new DataSet();
                    DataTable dt = new DataTable();
                    SqlDataAdapter sda = new SqlDataAdapter(command);
                    sda.Fill(dt);
                    newEmployeeDataGrid.DataSource = dt;
                    connection.Close();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }
            }
            if (dateRangeFilter.Checked == true && !String.IsNullOrEmpty(firstNameSearch.Text) && !String.IsNullOrEmpty(lastNameSearch.Text))
            {
                try
                {
                    String query = "select * from EmployeeRecords Where StartDate >='" + startDateSearch.Value + "' AND StartDate <='" + endDateSearch.Value + "' AND FirstName='" + firstNameSearch.Text + "' And LastName='" + lastNameSearch.Text + "'";
                    SqlConnection connection = new SqlConnection(connectionString);
                    SqlCommand command = new SqlCommand(query, connection);
                    connection.Open();
                    DataSet ds = new DataSet();
                    DataTable dt = new DataTable();
                    SqlDataAdapter sda = new SqlDataAdapter(command);
                    sda.Fill(dt);
                    newEmployeeDataGrid.DataSource = dt;
                    connection.Close();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }
            }
            //Ad Complete
            if (dateRangeFilter.Checked == true && String.IsNullOrEmpty(firstNameSearch.Text) && String.IsNullOrEmpty(lastNameSearch.Text) && adCompleteFilter.Checked == true && adIncompleteFilter.Checked == false && empathCompleteFilter.Checked == false && empathIncompleteFilter.Checked == false && rfsReceiveFilter.Checked == false && rfsNotReceiveFilter.Checked == false && pdfSentFilter.Checked == false && pdfNotSentFilter.Checked == false && offerDeclinedFilter.Checked == false && recordsCompleteFilter.Checked == false)
            {
                firstNameSearch.Text = "";
                lastNameSearch.Text = "";
                try
                {
                    String query = "select * from EmployeeRecords Where StartDate >='" + startDateSearch.Value + "' AND StartDate <='" + endDateSearch.Value + "' AND ADAccount = 'True'";
                    SqlConnection connection = new SqlConnection(connectionString);
                    SqlCommand command = new SqlCommand(query, connection);
                    connection.Open();
                    DataSet ds = new DataSet();
                    DataTable dt = new DataTable();
                    SqlDataAdapter sda = new SqlDataAdapter(command);
                    sda.Fill(dt);
                    newEmployeeDataGrid.DataSource = dt;
                    connection.Close();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }
            }
            //Ad InComplete
            if (dateRangeFilter.Checked == true && String.IsNullOrEmpty(firstNameSearch.Text) && String.IsNullOrEmpty(lastNameSearch.Text) && adCompleteFilter.Checked == false && adIncompleteFilter.Checked == true && empathCompleteFilter.Checked == false && empathIncompleteFilter.Checked == false && rfsReceiveFilter.Checked == false && rfsNotReceiveFilter.Checked == false && pdfSentFilter.Checked == false && pdfNotSentFilter.Checked == false && offerDeclinedFilter.Checked == false && recordsCompleteFilter.Checked == false)
            {
                firstNameSearch.Text = "";
                lastNameSearch.Text = "";
                try
                {
                    String query = "select * from EmployeeRecords Where StartDate >='" + startDateSearch.Value + "' AND StartDate <='" + endDateSearch.Value + "' AND ADAccount = 'False'";
                    SqlConnection connection = new SqlConnection(connectionString);
                    SqlCommand command = new SqlCommand(query, connection);
                    connection.Open();
                    DataSet ds = new DataSet();
                    DataTable dt = new DataTable();
                    SqlDataAdapter sda = new SqlDataAdapter(command);
                    sda.Fill(dt);
                    newEmployeeDataGrid.DataSource = dt;
                    connection.Close();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }
            }
            // Empath Complete

            if (dateRangeFilter.Checked == true && String.IsNullOrEmpty(firstNameSearch.Text) && String.IsNullOrEmpty(lastNameSearch.Text) && adCompleteFilter.Checked == false && adIncompleteFilter.Checked == false && empathCompleteFilter.Checked == true && empathIncompleteFilter.Checked == false && rfsReceiveFilter.Checked == false && rfsNotReceiveFilter.Checked == false && pdfSentFilter.Checked == false && pdfNotSentFilter.Checked == false && offerDeclinedFilter.Checked == false && recordsCompleteFilter.Checked == false)
            {
                firstNameSearch.Text = "";
                lastNameSearch.Text = "";
                try
                {
                    String query = "select * from EmployeeRecords Where StartDate >='" + startDateSearch.Value + "' AND StartDate <='" + endDateSearch.Value + "' AND Empath = 'True'";
                    SqlConnection connection = new SqlConnection(connectionString);
                    SqlCommand command = new SqlCommand(query, connection);
                    connection.Open();
                    DataSet ds = new DataSet();
                    DataTable dt = new DataTable();
                    SqlDataAdapter sda = new SqlDataAdapter(command);
                    sda.Fill(dt);
                    newEmployeeDataGrid.DataSource = dt;
                    connection.Close();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }
            }
            // Empath InComplete

            if (dateRangeFilter.Checked == true && String.IsNullOrEmpty(firstNameSearch.Text) && String.IsNullOrEmpty(lastNameSearch.Text) && adCompleteFilter.Checked == false && adIncompleteFilter.Checked == false && empathCompleteFilter.Checked == false && empathIncompleteFilter.Checked == true && rfsReceiveFilter.Checked == false && rfsNotReceiveFilter.Checked == false && pdfSentFilter.Checked == false && pdfNotSentFilter.Checked == false && offerDeclinedFilter.Checked == false && recordsCompleteFilter.Checked == false)
            {
                firstNameSearch.Text = "";
                lastNameSearch.Text = "";
                try
                {
                    String query = "select * from EmployeeRecords Where StartDate >='" + startDateSearch.Value + "' AND StartDate <='" + endDateSearch.Value + "' AND Empath = 'False'";
                    SqlConnection connection = new SqlConnection(connectionString);
                    SqlCommand command = new SqlCommand(query, connection);
                    connection.Open();
                    DataSet ds = new DataSet();
                    DataTable dt = new DataTable();
                    SqlDataAdapter sda = new SqlDataAdapter(command);
                    sda.Fill(dt);
                    newEmployeeDataGrid.DataSource = dt;
                    connection.Close();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }
            }
            // RFS Received
            if (dateRangeFilter.Checked == true && String.IsNullOrEmpty(firstNameSearch.Text) && String.IsNullOrEmpty(lastNameSearch.Text) && adCompleteFilter.Checked == false && adIncompleteFilter.Checked == false && empathCompleteFilter.Checked == false && empathIncompleteFilter.Checked == false && rfsReceiveFilter.Checked == true && rfsNotReceiveFilter.Checked == false && pdfSentFilter.Checked == false && pdfNotSentFilter.Checked == false && offerDeclinedFilter.Checked == false && recordsCompleteFilter.Checked == false)
            {
                firstNameSearch.Text = "";
                lastNameSearch.Text = "";
                try
                {
                    String query = "select * from EmployeeRecords Where StartDate >='" + startDateSearch.Value + "' AND StartDate <='" + endDateSearch.Value + "' AND RFS = 'True'";
                    SqlConnection connection = new SqlConnection(connectionString);
                    SqlCommand command = new SqlCommand(query, connection);
                    connection.Open();
                    DataSet ds = new DataSet();
                    DataTable dt = new DataTable();
                    SqlDataAdapter sda = new SqlDataAdapter(command);
                    sda.Fill(dt);
                    newEmployeeDataGrid.DataSource = dt;
                    connection.Close();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }
            }
            // RFS Not Received

            if (dateRangeFilter.Checked == true && String.IsNullOrEmpty(firstNameSearch.Text) && String.IsNullOrEmpty(lastNameSearch.Text) && adCompleteFilter.Checked == false && adIncompleteFilter.Checked == false && empathCompleteFilter.Checked == false && empathIncompleteFilter.Checked == false && rfsReceiveFilter.Checked == false && rfsNotReceiveFilter.Checked == true && pdfSentFilter.Checked == false && pdfNotSentFilter.Checked == false && offerDeclinedFilter.Checked == false && recordsCompleteFilter.Checked == false)
            {
                firstNameSearch.Text = "";
                lastNameSearch.Text = "";
                try
                {
                    String query = "select * from EmployeeRecords Where StartDate >='" + startDateSearch.Value + "' AND StartDate <='" + endDateSearch.Value + "' AND RFS = 'False'";
                    SqlConnection connection = new SqlConnection(connectionString);
                    SqlCommand command = new SqlCommand(query, connection);
                    connection.Open();
                    DataSet ds = new DataSet();
                    DataTable dt = new DataTable();
                    SqlDataAdapter sda = new SqlDataAdapter(command);
                    sda.Fill(dt);
                    newEmployeeDataGrid.DataSource = dt;
                    connection.Close();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }
            }
            // Encrypted email sent
            if (dateRangeFilter.Checked == true && String.IsNullOrEmpty(firstNameSearch.Text) && String.IsNullOrEmpty(lastNameSearch.Text) && adCompleteFilter.Checked == false && adIncompleteFilter.Checked == false && empathCompleteFilter.Checked == false && empathIncompleteFilter.Checked == false && rfsReceiveFilter.Checked == false && rfsNotReceiveFilter.Checked == false && pdfSentFilter.Checked == true && pdfNotSentFilter.Checked == false && offerDeclinedFilter.Checked == false && recordsCompleteFilter.Checked == false)
            {
                firstNameSearch.Text = "";
                lastNameSearch.Text = "";
                try
                {
                    String query = "select * from EmployeeRecords Where StartDate >='" + startDateSearch.Value + "' AND StartDate <='" + endDateSearch.Value + "' AND EmailSent = 'True'";
                    SqlConnection connection = new SqlConnection(connectionString);
                    SqlCommand command = new SqlCommand(query, connection);
                    connection.Open();
                    DataSet ds = new DataSet();
                    DataTable dt = new DataTable();
                    SqlDataAdapter sda = new SqlDataAdapter(command);
                    sda.Fill(dt);
                    newEmployeeDataGrid.DataSource = dt;
                    connection.Close();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }
            }
            // Encrypted email Not sent
            if (dateRangeFilter.Checked == true && String.IsNullOrEmpty(firstNameSearch.Text) && String.IsNullOrEmpty(lastNameSearch.Text) && adCompleteFilter.Checked == false && adIncompleteFilter.Checked == false && empathCompleteFilter.Checked == false && empathIncompleteFilter.Checked == false && rfsReceiveFilter.Checked == false && rfsNotReceiveFilter.Checked == false && pdfSentFilter.Checked == false && pdfNotSentFilter.Checked == true && offerDeclinedFilter.Checked == false && recordsCompleteFilter.Checked == false)
            {
                firstNameSearch.Text = "";
                lastNameSearch.Text = "";
                try
                {
                    String query = "select * from EmployeeRecords Where StartDate >='" + startDateSearch.Value + "' AND StartDate <='" + endDateSearch.Value + "' AND EmailSent = 'False'";
                    SqlConnection connection = new SqlConnection(connectionString);
                    SqlCommand command = new SqlCommand(query, connection);
                    connection.Open();
                    DataSet ds = new DataSet();
                    DataTable dt = new DataTable();
                    SqlDataAdapter sda = new SqlDataAdapter(command);
                    sda.Fill(dt);
                    newEmployeeDataGrid.DataSource = dt;
                    connection.Close();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }
                //Decline Offer
            }
            if (dateRangeFilter.Checked == true && String.IsNullOrEmpty(firstNameSearch.Text) && String.IsNullOrEmpty(lastNameSearch.Text) && adCompleteFilter.Checked == false && adIncompleteFilter.Checked == false && empathCompleteFilter.Checked == false && empathIncompleteFilter.Checked == false && rfsReceiveFilter.Checked == false && rfsNotReceiveFilter.Checked == false && pdfSentFilter.Checked == false && pdfNotSentFilter.Checked == false && offerDeclinedFilter.Checked == true && recordsCompleteFilter.Checked == false)
            {
                firstNameSearch.Text = "";
                lastNameSearch.Text = "";
                try
                {
                    String query = "select * from EmployeeRecords Where StartDate >='" + startDateSearch.Value + "' AND StartDate <='" + endDateSearch.Value + "' AND OfferDeclined = 'True'";
                    SqlConnection connection = new SqlConnection(connectionString);
                    SqlCommand command = new SqlCommand(query, connection);
                    connection.Open();
                    DataSet ds = new DataSet();
                    DataTable dt = new DataTable();
                    SqlDataAdapter sda = new SqlDataAdapter(command);
                    sda.Fill(dt);
                    newEmployeeDataGrid.DataSource = dt;
                    connection.Close();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }
            }
            // Complete records
            if (dateRangeFilter.Checked == true && String.IsNullOrEmpty(firstNameSearch.Text) && String.IsNullOrEmpty(lastNameSearch.Text) && adCompleteFilter.Checked == false && adIncompleteFilter.Checked == false && empathCompleteFilter.Checked == false && empathIncompleteFilter.Checked == false && rfsReceiveFilter.Checked == false && rfsNotReceiveFilter.Checked == false && pdfSentFilter.Checked == false && pdfNotSentFilter.Checked == false && offerDeclinedFilter.Checked == false && recordsCompleteFilter.Checked == true)
            {
                firstNameSearch.Text = "";
                lastNameSearch.Text = "";
                try
                {
                    String query = "select * from EmployeeRecords Where StartDate >='" + startDateSearch.Value + "' AND StartDate <='" + endDateSearch.Value + "' AND Complete = 'True'";
                    SqlConnection connection = new SqlConnection(connectionString);
                    SqlCommand command = new SqlCommand(query, connection);
                    connection.Open();
                    DataSet ds = new DataSet();
                    DataTable dt = new DataTable();
                    SqlDataAdapter sda = new SqlDataAdapter(command);
                    sda.Fill(dt);
                    newEmployeeDataGrid.DataSource = dt;
                    connection.Close();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }
            }

            /// New search connectiondition

            //Ad Complete
            if (dateRangeFilter.Checked == false && String.IsNullOrEmpty(firstNameSearch.Text) && String.IsNullOrEmpty(lastNameSearch.Text) && adCompleteFilter.Checked == true && adIncompleteFilter.Checked == false && empathCompleteFilter.Checked == false && empathIncompleteFilter.Checked == false && rfsReceiveFilter.Checked == false && rfsNotReceiveFilter.Checked == false && pdfSentFilter.Checked == false && pdfNotSentFilter.Checked == false && offerDeclinedFilter.Checked == false && recordsCompleteFilter.Checked == false)
            {
                firstNameSearch.Text = "";
                lastNameSearch.Text = "";
                try
                {
                    String query = "select * from EmployeeRecords Where ADAccount = 'True'";
                    SqlConnection connection = new SqlConnection(connectionString);
                    SqlCommand command = new SqlCommand(query, connection);
                    connection.Open();
                    DataSet ds = new DataSet();
                    DataTable dt = new DataTable();
                    SqlDataAdapter sda = new SqlDataAdapter(command);
                    sda.Fill(dt);
                    newEmployeeDataGrid.DataSource = dt;
                    connection.Close();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }
            }
            //Ad InComplete
            if (dateRangeFilter.Checked == false && String.IsNullOrEmpty(firstNameSearch.Text) && String.IsNullOrEmpty(lastNameSearch.Text) && adCompleteFilter.Checked == false && adIncompleteFilter.Checked == true && empathCompleteFilter.Checked == false && empathIncompleteFilter.Checked == false && rfsReceiveFilter.Checked == false && rfsNotReceiveFilter.Checked == false && pdfSentFilter.Checked == false && pdfNotSentFilter.Checked == false && offerDeclinedFilter.Checked == false && recordsCompleteFilter.Checked == false)
            {
                firstNameSearch.Text = "";
                lastNameSearch.Text = "";
                try
                {
                    String query = "select * from EmployeeRecords Where ADAccount = 'False'";
                    SqlConnection connection = new SqlConnection(connectionString);
                    SqlCommand command = new SqlCommand(query, connection);
                    connection.Open();
                    DataSet ds = new DataSet();
                    DataTable dt = new DataTable();
                    SqlDataAdapter sda = new SqlDataAdapter(command);
                    sda.Fill(dt);
                    newEmployeeDataGrid.DataSource = dt;
                    connection.Close();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }
            }
            // Empath Complete

            if (dateRangeFilter.Checked == false && String.IsNullOrEmpty(firstNameSearch.Text) && String.IsNullOrEmpty(lastNameSearch.Text) && adCompleteFilter.Checked == false && adIncompleteFilter.Checked == false && empathCompleteFilter.Checked == true && empathIncompleteFilter.Checked == false && rfsReceiveFilter.Checked == false && rfsNotReceiveFilter.Checked == false && pdfSentFilter.Checked == false && pdfNotSentFilter.Checked == false && offerDeclinedFilter.Checked == false && recordsCompleteFilter.Checked == false)
            {
                firstNameSearch.Text = "";
                lastNameSearch.Text = "";
                try
                {
                    String query = "select * from EmployeeRecords Where Empath = 'True'";
                    SqlConnection connection = new SqlConnection(connectionString);
                    SqlCommand command = new SqlCommand(query, connection);
                    connection.Open();
                    DataSet ds = new DataSet();
                    DataTable dt = new DataTable();
                    SqlDataAdapter sda = new SqlDataAdapter(command);
                    sda.Fill(dt);
                    newEmployeeDataGrid.DataSource = dt;
                    connection.Close();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }
            }
            // Empath InComplete

            if (dateRangeFilter.Checked == false && String.IsNullOrEmpty(firstNameSearch.Text) && String.IsNullOrEmpty(lastNameSearch.Text) && adCompleteFilter.Checked == false && adIncompleteFilter.Checked == false && empathCompleteFilter.Checked == false && empathIncompleteFilter.Checked == true && rfsReceiveFilter.Checked == false && rfsNotReceiveFilter.Checked == false && pdfSentFilter.Checked == false && pdfNotSentFilter.Checked == false && offerDeclinedFilter.Checked == false && recordsCompleteFilter.Checked == false)
            {
                firstNameSearch.Text = "";
                lastNameSearch.Text = "";
                try
                {
                    String query = "select * from EmployeeRecords Where Empath = 'False'";
                    SqlConnection connection = new SqlConnection(connectionString);
                    SqlCommand command = new SqlCommand(query, connection);
                    connection.Open();
                    DataSet ds = new DataSet();
                    DataTable dt = new DataTable();
                    SqlDataAdapter sda = new SqlDataAdapter(command);
                    sda.Fill(dt);
                    newEmployeeDataGrid.DataSource = dt;
                    connection.Close();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }
            }
            // RFS Received
            if (dateRangeFilter.Checked == false && String.IsNullOrEmpty(firstNameSearch.Text) && String.IsNullOrEmpty(lastNameSearch.Text) && adCompleteFilter.Checked == false && adIncompleteFilter.Checked == false && empathCompleteFilter.Checked == false && empathIncompleteFilter.Checked == false && rfsReceiveFilter.Checked == true && rfsNotReceiveFilter.Checked == false && pdfSentFilter.Checked == false && pdfNotSentFilter.Checked == false && offerDeclinedFilter.Checked == false && recordsCompleteFilter.Checked == false)
            {
                firstNameSearch.Text = "";
                lastNameSearch.Text = "";
                try
                {
                    String query = "select * from EmployeeRecords Where RFS = 'True'";
                    SqlConnection connection = new SqlConnection(connectionString);
                    SqlCommand command = new SqlCommand(query, connection);
                    connection.Open();
                    DataSet ds = new DataSet();
                    DataTable dt = new DataTable();
                    SqlDataAdapter sda = new SqlDataAdapter(command);
                    sda.Fill(dt);
                    newEmployeeDataGrid.DataSource = dt;
                    connection.Close();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }
            }
            // RFS Not Received

            if (dateRangeFilter.Checked == false && String.IsNullOrEmpty(firstNameSearch.Text) && String.IsNullOrEmpty(lastNameSearch.Text) && adCompleteFilter.Checked == false && adIncompleteFilter.Checked == false && empathCompleteFilter.Checked == false && empathIncompleteFilter.Checked == false && rfsReceiveFilter.Checked == false && rfsNotReceiveFilter.Checked == true && pdfSentFilter.Checked == false && pdfNotSentFilter.Checked == false && offerDeclinedFilter.Checked == false && recordsCompleteFilter.Checked == false)
            {
                firstNameSearch.Text = "";
                lastNameSearch.Text = "";
                try
                {
                    String query = "select * from EmployeeRecords Where RFS = 'False'";
                    SqlConnection connection = new SqlConnection(connectionString);
                    SqlCommand command = new SqlCommand(query, connection);
                    connection.Open();
                    DataSet ds = new DataSet();
                    DataTable dt = new DataTable();
                    SqlDataAdapter sda = new SqlDataAdapter(command);
                    sda.Fill(dt);
                    newEmployeeDataGrid.DataSource = dt;
                    connection.Close();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }
            }
            // Encrypted email sent
            if (dateRangeFilter.Checked == false && String.IsNullOrEmpty(firstNameSearch.Text) && String.IsNullOrEmpty(lastNameSearch.Text) && adCompleteFilter.Checked == false && adIncompleteFilter.Checked == false && empathCompleteFilter.Checked == false && empathIncompleteFilter.Checked == false && rfsReceiveFilter.Checked == false && rfsNotReceiveFilter.Checked == false && pdfSentFilter.Checked == true && pdfNotSentFilter.Checked == false && offerDeclinedFilter.Checked == false && recordsCompleteFilter.Checked == false)
            {
                firstNameSearch.Text = "";
                lastNameSearch.Text = "";
                try
                {
                    String query = "select * from EmployeeRecords Where EmailSent = 'True'";
                    SqlConnection connection = new SqlConnection(connectionString);
                    SqlCommand command = new SqlCommand(query, connection);
                    connection.Open();
                    DataSet ds = new DataSet();
                    DataTable dt = new DataTable();
                    SqlDataAdapter sda = new SqlDataAdapter(command);
                    sda.Fill(dt);
                    newEmployeeDataGrid.DataSource = dt;
                    connection.Close();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }
            }
            // Encrypted email Not sent
            if (dateRangeFilter.Checked == false && String.IsNullOrEmpty(firstNameSearch.Text) && String.IsNullOrEmpty(lastNameSearch.Text) && adCompleteFilter.Checked == false && adIncompleteFilter.Checked == false && empathCompleteFilter.Checked == false && empathIncompleteFilter.Checked == false && rfsReceiveFilter.Checked == false && rfsNotReceiveFilter.Checked == false && pdfSentFilter.Checked == false && pdfNotSentFilter.Checked == true && offerDeclinedFilter.Checked == false && recordsCompleteFilter.Checked == false)
            {
                firstNameSearch.Text = "";
                lastNameSearch.Text = "";
                try
                {
                    String query = "select * from EmployeeRecords Where EmailSent = 'False'";
                    SqlConnection connection = new SqlConnection(connectionString);
                    SqlCommand command = new SqlCommand(query, connection);
                    connection.Open();
                    DataSet ds = new DataSet();
                    DataTable dt = new DataTable();
                    SqlDataAdapter sda = new SqlDataAdapter(command);
                    sda.Fill(dt);
                    newEmployeeDataGrid.DataSource = dt;
                    connection.Close();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }
                //Decline Offer
            }
            if (dateRangeFilter.Checked == false && String.IsNullOrEmpty(firstNameSearch.Text) && String.IsNullOrEmpty(lastNameSearch.Text) && adCompleteFilter.Checked == false && adIncompleteFilter.Checked == false && empathCompleteFilter.Checked == false && empathIncompleteFilter.Checked == false && rfsReceiveFilter.Checked == false && rfsNotReceiveFilter.Checked == false && pdfSentFilter.Checked == false && pdfNotSentFilter.Checked == false && offerDeclinedFilter.Checked == true && recordsCompleteFilter.Checked == false)
            {
                firstNameSearch.Text = "";
                lastNameSearch.Text = "";
                try
                {
                    String query = "select * from EmployeeRecords Where OfferDeclined = 'True'";
                    SqlConnection connection = new SqlConnection(connectionString);
                    SqlCommand command = new SqlCommand(query, connection);
                    connection.Open();
                    DataSet ds = new DataSet();
                    DataTable dt = new DataTable();
                    SqlDataAdapter sda = new SqlDataAdapter(command);
                    sda.Fill(dt);
                    newEmployeeDataGrid.DataSource = dt;
                    connection.Close();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }
            }
            // Complete records
            if (dateRangeFilter.Checked == false && String.IsNullOrEmpty(firstNameSearch.Text) && String.IsNullOrEmpty(lastNameSearch.Text) && adCompleteFilter.Checked == false && adIncompleteFilter.Checked == false && empathCompleteFilter.Checked == false && empathIncompleteFilter.Checked == false && rfsReceiveFilter.Checked == false && rfsNotReceiveFilter.Checked == false && pdfSentFilter.Checked == false && pdfNotSentFilter.Checked == false && offerDeclinedFilter.Checked == false && recordsCompleteFilter.Checked == true)
            {
                firstNameSearch.Text = "";
                lastNameSearch.Text = "";
                try
                {
                    String query = "select * from EmployeeRecords Where Complete = 'True'";
                    SqlConnection connection = new SqlConnection(connectionString);
                    SqlCommand command = new SqlCommand(query, connection);
                    connection.Open();
                    DataSet ds = new DataSet();
                    DataTable dt = new DataTable();
                    SqlDataAdapter sda = new SqlDataAdapter(command);
                    sda.Fill(dt);
                    newEmployeeDataGrid.DataSource = dt;
                    connection.Close();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }
            }
        }
        
        /// <summary>
        /// This method exports the entries displayed in the data grid
        /// </summary>
        /// <param name="tablelist"></param>
        /// <param name="excelFilename"></param>
        private void exportNewEmployeeEntries()
        {
            // creating Excel Application
            Microsoft.Office.Interop.Excel._Application app = new Microsoft.Office.Interop.Excel.Application();
            // creating new WorkBook within Excel application
            Microsoft.Office.Interop.Excel._Workbook workbook = app.Workbooks.Add(Type.Missing);
            // creating new Excel sheet in workbook
            Microsoft.Office.Interop.Excel._Worksheet worksheet = null;

            // see the excel sheet behind the program
            app.Visible = true;
            // get the reference of first sheet. By default its name is Sheet1. store its reference
            // to worksheet
            worksheet = workbook.Sheets["Sheet1"];
            worksheet = workbook.ActiveSheet;
            // changing the name of active sheet
            worksheet.Name = "Employee Records Report";
            // storing header part in Excel
            for (int i = 1; i < newEmployeeDataGrid.Columns.Count + 1; i++)
            {
                worksheet.Cells[1, i] = newEmployeeDataGrid.Columns[i - 1].HeaderText;
            }
            // storing Each row and column value to excel sheet
            for (int i = 0; i < newEmployeeDataGrid.Rows.Count - 1; i++)
            {
                for (int j = 0; j < newEmployeeDataGrid.Columns.Count; j++)
                {
                    worksheet.Cells[i + 2, j + 1] = newEmployeeDataGrid.Rows[i].Cells[j].Value.ToString();
                }
            }

            // save the application

            if (startDateSearch.Value.ToString("dddd, dd MMMM yyyy") == endDateSearch.Value.ToString("dddd, dd MMMM yyyy"))
            {
                workbook.SaveAs(Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments) + "\\All Employee Records.xlsx", Type.Missing, Type.Missing, Type.Missing, Type.Missing, Type.Missing, Microsoft.Office.Interop.Excel.XlSaveAsAccessMode.xlExclusive, Type.Missing, Type.Missing, Type.Missing, Type.Missing);
            }
            else
            {
                workbook.SaveAs(Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments) + "\\" + startDateSearch.Value.ToString("dddd, dd MMMM yyyy") + " - " + endDateSearch.Value.ToString("dddd, dd MMMM yyyy") + " Employee Records.xlsx", Type.Missing, Type.Missing, Type.Missing, Type.Missing, Type.Missing, Microsoft.Office.Interop.Excel.XlSaveAsAccessMode.xlExclusive, Type.Missing, Type.Missing, Type.Missing, Type.Missing);
            }

            MessageBox.Show("Employee Records Report have been saved to your Documents", "Export to Excel File", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        //This method enables spellcheck
        private void newEmployeeEntrySpellCheck()
        {
            ElementHost elementHost1 = new ElementHost();
            textBox = new System.Windows.Controls.TextBox();
            textBox.TextWrapping = System.Windows.TextWrapping.Wrap;
            textBox.AcceptsReturn = true;
            textBox.FontSize = 16;
            textBox.FontFamily = new System.Windows.Media.FontFamily("Times New Roman");
            textBox.SpellCheck.IsEnabled = true;    
            elementHost1.Child = textBox;



        }

        /// <summary>
        /// Loads spell check when the application loads
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Onboarding_Load(object sender, EventArgs e)
        {
            newEmployeeEntrySpellCheck();


        }

        /// <summary>
        /// This method clears the form
        /// </summary>
        private void clearNewEmployeeEntriesForm()
        {
            firstName.Text = String.Empty;
            lastName.Text = String.Empty;
            employeeID.Text = String.Empty;
            accessPin.Text = String.Empty;
            EplPpl.Text = String.Empty;
            personalEmail.Text = String.Empty;
            additionalNotes.Text = String.Empty;
            declineOffer.Checked = false;
            reHire.Checked = false;
            adAccountComplete.Checked = false;
            empathEntered.Checked = false;
            rfsReceived.Checked = false;
            pdfFileEmailed.Checked = false;
            newEmployeeComplete.Checked = false;
            recordID.Text = string.Empty;
            newEmployeeDataGrid.DataSource = null;
            grhEmail.Text = String.Empty;

        }

        /// <summary>
        /// This method clears the search form
        /// </summary>
        private void clearNewEmployeeSearch()
        {
            firstNameSearch.Text = String.Empty;
            lastNameSearch.Text = String.Empty;
            dateRangeFilter.Checked = false;
            adCompleteFilter.Checked = false;
            adIncompleteFilter.Checked = false;
            rfsReceiveFilter.Checked = false;
            rfsNotReceiveFilter.Checked = false;
            empathCompleteFilter.Checked = false;
            empathIncompleteFilter.Checked = false;
            pdfSentFilter.Checked = false;
            pdfNotSentFilter.Checked = false;
            recordsCompleteFilter.Checked = false;
            recordsIncompleteFilter.Checked = false;
            offerDeclinedFilter.Checked = false;
            newEmployeeDataGrid.DataSource = null;

        }
        /// <summary>
        /// This button add new entry
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void NEE_Save_Btn__Click(object sender, EventArgs e)
        {
            validateNewUserInput();
            clearNewEmployeeEntriesForm();
        }

        /// <summary>
        /// This button endit new entry
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void NEE_Edit_Btn_Click(object sender, EventArgs e)
        {
            editNewdataBaseEntry();
        }

        /// <summary>
        /// This button delete new entry
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void NEE_Delete_Btn__Click(object sender, EventArgs e)
        {
            deleteNewEmployeeEntry();           
        }

        /// <summary>
        /// This button resets the new entry form
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void NEE_Reset_Btn__Click(object sender, EventArgs e)
        {
            clearNewEmployeeEntriesForm();
        }

        //This button perform search fro new entries
        private void NES_Search_Btn__Click(object sender, EventArgs e)
        {
            newEmployeeEntrySearch();
        }

        /// <summary>
        /// This button clears the new entry search form
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void NES_Reset_Btn__Click(object sender, EventArgs e)
        {
            clearNewEmployeeSearch();
        }

        /// <summary>
        /// This button extorts the display search results
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void exportNewEmployeeEntries_Btn_Click(object sender, EventArgs e)
        {
            exportNewEmployeeEntries();
        }

        /// <summary>
        /// This button completes the new employee entry done by help desk
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void NES_Save_Btn__Click(object sender, EventArgs e)
        {
            completeNewDataBaseEntry();
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void NES_Clear_Btn_Click(object sender, EventArgs e)
        {
            clearNewEmployeeEntriesForm();
            clearNewEmployeeSearch();
        }

        /// <summary>
        /// Check empath numbers entry
        /// </summary>
        private void statusCheck()
        {
            string blank = "";
            double empNum = 0;

            if (accessLevel == "Onboarding_IT")
            {
                try
                {
                    String query = "select Count(*) From EmployeeRecords Where StartDate >='" + DateTime.Today.AddDays(2) + "' AND StartDate <='" + DateTime.Today.AddDays(10) + "' AND EmployeeNumber='" + blank + "'";
                    SqlConnection con = new SqlConnection(connectionString);
                    SqlCommand cmd = new SqlCommand(query, con);
                    con.Open();
                    empNum = Convert.ToInt64(cmd.ExecuteScalar());
                    con.Close();

                    if (empNum > 0)
                    {
                        MessageBox.Show("There are outstanding Employee numbers for " + empNum.ToString() + " accounts that are due on " + DateTime.Today.AddDays(3).ToString() + ".\n This is needed by Help Desk to confirm the user have an Empath entry.", "Missing Employee Numbers.", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    }
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }
            }

            if (accessLevel == "Helpdesk Support")
            {
                try
                {
                    String query = "select Count(*) From EmployeeRecords Where StartDate ='" + DateTime.Today.AddDays(3) + "' AND Empath='false'";
                    SqlConnection con = new SqlConnection(connectionString);
                    SqlCommand cmd = new SqlCommand(query, con);
                    con.Open();
                    empNum = Convert.ToInt32(cmd.ExecuteScalar());
                    con.Close();

                    if (empNum > 0)
                    {
                        MessageBox.Show("There are outstanding Empath Entries for " + empNum.ToString() + " accounts that is due on " + DateTime.Today.AddDays(3).ToString(), "Missing Empath Entries", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    }
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }
            }
            if (accessLevel == "Helpdesk Admin")
            {
                try
                {
                    String query = "select Count(*) From EmployeeRecords Where StartDate >='" + DateTime.Today.AddDays(2) + "' AND StartDate <='" + DateTime.Today.AddDays(10) + "' AND EmployeeNumber='" + blank + "'";
                    SqlConnection con = new SqlConnection(connectionString);
                    SqlCommand cmd = new SqlCommand(query, con);
                    con.Open();
                    empNum = Convert.ToInt64(cmd.ExecuteScalar());
                    con.Close();

                    if (empNum > 0)
                    {
                        MessageBox.Show("There are outstanding Employee numbers for " + empNum.ToString() + " accounts that are due on " + DateTime.Today.AddDays(3).ToString() + ".\n This is needed by Help Desk to confirm the user have an Empath entry.", "Missing Employee Numbers.", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    }
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }

                try
                {
                    String query = "select Count(*) From EmployeeRecords Where StartDate ='" + DateTime.Today.AddDays(3) + "' AND Empath='false'";
                    SqlConnection con = new SqlConnection(connectionString);
                    SqlCommand cmd = new SqlCommand(query, con);
                    con.Open();
                    empNum = Convert.ToInt32(cmd.ExecuteScalar());
                    con.Close();

                    if (empNum > 0)
                    {
                        MessageBox.Show("There are outstanding Empath Entries for " + empNum.ToString() + " accounts that is due on " + DateTime.Today.AddDays(3).ToString(), "Missing Empath Entries", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                    }
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }


            }
        }
               
        /// <summary>
        /// Checks version and build of application
        /// </summary>
        private void CheckBuild()
        {
            string versionCheck;
            string buildCheck;

            using (SqlConnection con = new SqlConnection(connectionString))
            {
                string query = "select * from Firmware";
                using (SqlDataAdapter adap = new SqlDataAdapter(query, con))
                {
                    con.Open();
                    DataTable dts = new DataTable();

                    adap.Fill(dts);

                    if (dts.Rows.Count > 0)
                    {
                        versionCheck = dts.Rows[0]["Version"].ToString().Trim();
                        buildCheck = dts.Rows[0]["Build"].ToString().Trim();

                        if (versionCheck == currentVersion)
                        {
                            currentVersionLbl.Text = versionCheck;
                            currentBuildLbl.Text = buildCheck;
                            ApplicationStatus.Text = "Application up to date";
                        }
                        else
                        {
                            ApplicationStatus.Text = "Application out of date";
                            currentVersionLbl.Text = currentVersion;
                            currentBuildLbl.Text = currentBuild;
                            MessageBox.Show("There is an update available.", "Application Update", MessageBoxButtons.OK, MessageBoxIcon.Information);
                        }
                    }
                }
            }
        }

        /// <summary>
        /// Logs user's activity
        /// </summary>
        /// <param name="Task"></param>
        private void LogUserActivities(string Task, string ID)
        {
            try
            {
                DateTime uID = DateTime.Now;
                lastEditedDateTime = uID.ToString("yyyy-MM-dd-HH:mm");
                SqlConnection con = new SqlConnection(connectionString);
                SqlCommand cmd = new SqlCommand("Insert into UserLog (ID,FirstName,LastName,StartDate,EmployeeNumber,PersonalEmail, EPL_PPL, ADAccount, Empath, RFS, EmailSent, PinCode, AdditionalNote, OfferDeclined, Complete, LastEditedBy, DateEdited, ISID, Task) Values(@ID, @FirstName, @LastName, @StartDate, @EmployeeNumber, @PersonalEmail, @EPL_PPL, @ADAccount, @Empath, @RFS, @EmailSent, @PinCode, @AdditionalNote, @OfferDeclined, @Complete, @LastEditedBy, @DateEdited, @ISID, @Task)", con);
                cmd.Parameters.AddWithValue("@ID", ID);
                cmd.Parameters.AddWithValue("@FirstName", firstName.Text);
                cmd.Parameters.AddWithValue("@LastName", lastName.Text);
                cmd.Parameters.AddWithValue("@StartDate", NEE_StartDate_Picker.Value.ToString("dd-MMM-yy"));
                cmd.Parameters.AddWithValue("@EmployeeNumber", employeeID.Text);
                cmd.Parameters.AddWithValue("@PersonalEmail", personalEmail.Text);
                cmd.Parameters.AddWithValue("@GRHEmail", grhEmail.Text);
                cmd.Parameters.AddWithValue("@EPL_PPL", EplPpl.Text);
                cmd.Parameters.AddWithValue("@PinCode", accessPin.Text);
                cmd.Parameters.AddWithValue("@AdditionalNote", additionalNotes.Text);
                cmd.Parameters.AddWithValue("@ADAccount", ADAccount);
                cmd.Parameters.AddWithValue("@Empath", Empath);
                cmd.Parameters.AddWithValue("@RFS", Rfs);
                cmd.Parameters.AddWithValue("@EmailSent", emailSent);
                cmd.Parameters.AddWithValue("@Complete", recordComplete);
                cmd.Parameters.AddWithValue("@OfferDeclined", declineOfferV);
                cmd.Parameters.AddWithValue("@LastEditedBy", UserName.ToUpper());
                cmd.Parameters.AddWithValue("@DateEdited", lastEditedDateTime);
                cmd.Parameters.AddWithValue("@ISID", ISID);
                cmd.Parameters.AddWithValue("@Task", Task);
                con.Open();
                cmd.ExecuteNonQuery();
                con.Close();
            }
            catch
            {
            }
        }

        /// <summary>
        /// This button displays the user log
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void viewUserLogBtn_Click(object sender, EventArgs e)
        {
            userLog ULE = new userLog();
            ULE.ShowDialog();
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void firstNameSearch_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                newEmployeeEntrySearch();
            }
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void lastNameSearch_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                newEmployeeEntrySearch();
            }
        }

        /// <summary>
        /// This button opens the user setting
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void settingsBtn_Click(object sender, EventArgs e)
        {
            if (accessLevel == "Helpdesk Admin")
            {
                Setting settings = new Setting();
                settings.ShowDialog();
            }
            else
            {
                MessageBox.Show("User access modification can only be done by an admin","Access Denied",MessageBoxButtons.OK,MessageBoxIcon.Stop);
            }
        }

    }
}
