﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using MaterialSkin;
using MaterialSkin.Controls;

namespace Onboarding
{
    public partial class Setting : MaterialForm
    {
        private string connectionString = @"Password=AaY/X4*)Q6v'#ZBm;Persist Security Info=True;User ID=Onboarding;Initial Catalog=Onboarding;Data Source=ISPC0005";

        public Setting()
        {
            InitializeComponent();
            // Create a material theme manager and add the form to manage (this)
            var materialSkinManager = MaterialSkinManager.Instance;
            materialSkinManager.AddFormToManage(this);
            materialSkinManager.Theme = MaterialSkinManager.Themes.LIGHT;
            // Configure color schema
            materialSkinManager.ColorScheme = new ColorScheme(Primary.Blue800, Primary.Blue900, Primary.Blue500, Accent.LightBlue200, TextShade.WHITE);
            readDatabase();
        }


        private void readDatabase()
        {
            try
            {
                String query = "select * from AppUsers";
                SqlConnection connection = new SqlConnection(connectionString);
                SqlCommand command = new SqlCommand(query, connection);
                connection.Open();
                DataSet ds = new DataSet();
                DataTable dt = new DataTable();
                SqlDataAdapter sda = new SqlDataAdapter(command);
                sda.Fill(dt);
                accessLevelDisplayGrid.DataSource = dt;
                connection.Close();
                
               

            }
            catch
            {
                MessageBox.Show("Unable to read Database.", "Access Denied", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }

        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void accessLevelDisplayGrid_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {
            if (e.RowIndex >= 0)
            {
                DataGridViewRow row = this.accessLevelDisplayGrid.Rows[e.RowIndex];
                dUsername.Text = row.Cells["Username"].Value.ToString();
                dISID.Text = row.Cells["ISID"].Value.ToString();
                dAccessLevel.Text = row.Cells["AccessLevel"].Value.ToString();
            }
        }
        /// <summary>
        /// Add a user access
        /// </summary>
        private void addAccess()
        {
            SqlConnection con = new SqlConnection(connectionString);
            SqlCommand cmd = new SqlCommand("Insert into AppUsers (Username,ISID,AccessLevel) Values(@Username, @ISID, @AccessLevel)", con);            
            cmd.Parameters.AddWithValue("@Username", aUserName.Text);            
            cmd.Parameters.AddWithValue("@ISID", aISID.Text);
            cmd.Parameters.AddWithValue("@AccessLevel", aAccessLevel.SelectedItem.ToString());
            con.Open();
            cmd.ExecuteNonQuery();
            con.Close();
            MessageBox.Show("The user "+aUserName.Text+" Have been added","User Access Added",MessageBoxButtons.OK, MessageBoxIcon.Information);
        }
        /// <summary>
        /// Search for a user
        /// </summary>
        private void searchUser()
        {
            if (!String.IsNullOrEmpty(fUsername.Text))
            {
                try
                {
                    
                    String query = "select * from AppUsers Where username = '" + fUsername.Text + "'";
                    SqlConnection con = new SqlConnection(connectionString);
                    SqlCommand cmd = new SqlCommand(query, con);
                    con.Open();
                    DataSet ds = new DataSet();
                    DataTable dt = new DataTable();
                    SqlDataAdapter sda = new SqlDataAdapter(cmd);
                    sda.Fill(dt);
                    accessLevelDisplayGrid.DataSource = dt;
                    con.Close();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.ToString());
                }
            }
        }

        /// <summary>
        /// This method deletes a new employee entry
        /// </summary>
        private void deleteUserAccess()
        {
            SqlConnection connection = new SqlConnection(connectionString);
            SqlCommand command = new SqlCommand("Delete from AppUsers Where ISID='" + dISID.Text + "'", connection);
            connection.Open();
            command.ExecuteNonQuery();
            connection.Close();
            searchUser();

        }
        /// <summary>
        /// Add user access to app
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void addBtn_Click(object sender, EventArgs e)
        {
            addAccess();
        }

        /// <summary>
        /// Delete user access
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void deleteBtn_Click(object sender, EventArgs e)
        {
            deleteUserAccess();
        }
        /// <summary>
        /// Search for user
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void searchBtn_Click(object sender, EventArgs e)
        {
            searchUser();
        }
        /// <summary>
        /// Clear Form
        /// </summary>
        private void clearForm()
        {
            aUserName.Text = String.Empty;
            aISID.Text = String.Empty;
            dUsername.Text = String.Empty;
            dISID.Text = String.Empty;
            fUsername.Text = String.Empty;
            dAccessLevel.Text = String.Empty;
        }
        /// <summary>
        /// Reloads database
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void reloadBtn_Click(object sender, EventArgs e)
        {
            readDatabase();
        }
        /// <summary>
        /// This button clears the form
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void resetBtn_Click(object sender, EventArgs e)
        {
            clearForm();
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void fUsername_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                searchUser();
            }
        }
    }
    }

